//
//  GLImageSymbolizer.h
//  GLGeometryKit
//
//  Created by Jeffrey Early on 7/8/11.
//  Copyright 2011 Early Innovations, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <GLGeometryKit/GLGeometryKit.h>

@interface GLImageSymbolizer : GLSymbolizer {
	NSImage *image;
	GLPoint hotSpot;
	CGFloat rotation;
	CGSize size;
	CGLayerRef layer;
}


- (GLImageSymbolizer *) initWithImage: (NSImage *) anImage atHotSpot: (GLPoint) aPoint withRotation: (CGFloat) angle;
- (GLImageSymbolizer *) initWithImage: (NSImage *) anImage atHotSpot: (GLPoint) aPoint withRotation: (CGFloat) angle destinationSize: (CGSize) aSize;

// This is called just before the image is drawn for the first time.
- (CGLayerRef) layerForContext: (CGContextRef) context;

@property(strong) NSImage *image;
@property GLPoint hotSpot;
@property CGFloat rotation;
@property CGSize size;
@property(readwrite, strong, atomic) __attribute__((NSObject)) CGLayerRef layer;

@end
