//
//  GLSpatialObjectController.h
//  MapKit
//
//  Created by Jeffrey Early on 9/30/06.
//  Copyright 2006 Early Innovation. All rights reserved.
//

#import <Cocoa/Cocoa.h>

// A basic 'theme' controller that controls spatial objects (conforming to the GLSpatialObjectProtocol).
// This controller is bindings capable.
// Note that the difference between the 'Base' protocol and the full GLSpatialObjectController
// protocol is that the full protocol is what actualy GeoLife plugins are required to be a plugin.

@protocol GLSpatialObjectController

// How this particular plugin wishes to be identified to the user.
- (NSString*) name;

// This must return an NSArray of spatial objects that will be displayed
// on the MapView. The objects returned conform to the GLSpatialObject protocol
- (NSArray *) spatialObjects;

// Returns spatial objects within the bounds
//- (NSArray *) spatialObjectsWithFilter: (GLGeometry *) mapViewBounds;

// Returns the indexes of the selected objects
- (NSIndexSet *) spatialObjectSelectionIndexes;
- (void) setSpatialObjectSelectionIndexes: (NSIndexSet *) indexSet;
- (BOOL) removeSelectedSpatialObjects: (NSArray *) objects;
- (BOOL) addSelectedSpatialObjects: (NSArray *) objects;

// clean up and shut down
//- (void) terminateInstance;

@end
